# mkcallback.rb

Path: | dl/mkcallback.rb
Last Update: | Sat Oct 15 23:43:51 AUS Eastern Standard Time 2005

-*- ruby -*-

### Required files

mkmf type dlconfig

### Methods

mkfunc

### Public Instance methods

mkfunc(rettype, fnum, argc)

[Source]

    # File dl/mkcallback.rb, line 8
    def mkfunc(rettype, fnum, argc)
      args = (0..(argc-1)).collect{|i| "long arg#{i}"}.join(", ")

      subst_code = (0..(argc-1)).collect{|i|
        "  buff[#{i.to_s}] = arg#{i.to_s};"
      }.join("\n")

      ret_code =
        if( DLTYPE[rettype][:c2rb] )
          "  return #{DLTYPE[rettype][:rb2c]['retval']};"
        else
          "  /* no return value */"
        end

      code = [
        "static #{DLTYPE[rettype][:ctype]}",
        "rb_dl_callback_func_#{rettype.to_s}_#{fnum.to_s}(#{args})",
        "{",
        "  VALUE retval, proto, proc, obj;",
        "  VALUE argv[#{argc.to_s}];",
        "  int  argc;",
        "  long buff[#{argc.to_s}];",
        "",
        subst_code,
        "",
        "  obj = rb_hash_aref(DLFuncTable, rb_assoc_new(INT2NUM(#{rettype.to_s}),INT2NUM(#{fnum.to_s})));",
        "  proto = rb_ary_entry(obj, 0);",
        "  proc  = rb_ary_entry(obj, 1);",
        "  Check_Type(proto, T_STRING);",
        "  if( RSTRING(proto)->len >= #{argc.to_s} )",
        "    rb_raise(rb_eArgError, \"too many arguments\");",
        "  rb_dl_scan_callback_args(buff, RSTRING(proto)->ptr, &argc, argv);",
        "  retval = rb_funcall2(proc, id_call, argc, argv);",
        "",
        ret_code,
        "}",
      ].join("\n")

      return code
    end

[Validate]